#define  MAXDIGITS 5000
#define  DECNUMDIGITS (MAXDIGITS + (MAXDIGITS/1000))
#define  BASE_OVERHEAD 20000
#define  RECURSE_OVERHEAD (3*sizeof(int) + sizeof(decNumber))
#define  BUFSIZE 10
#include <decNumber.h>
#include <hpgcc49.h>
#ifndef HPAPINE
#include <fsystem.h>
#endif

#ifndef HPAPINE
extern unsigned int __heap_ptr, _heap_base_addr;
extern U32 syscallArg0(U32 index);
int freemem();
#endif

int decNumberIsLess(decNumber, decNumber, decContext);
void Vieta(int n, int k, decNumber * p, decContext set);
void init_V0(int k, int n, decContext set);

decNumber one, two, four;
#ifndef HPAPINE
FS_FILE *vfp, *v0fp;
#else
FILE *vfp, *v0fp;
#endif
decNumber V, V0;
int init_k, init_n, vhits = 0, thits = 0, optout = 0, recordsize;
char rpl[100], buf[BUFSIZE];

int main(int argc, char **argv)
{
	decNumber p;
	decContext set;
	int i, k = 0, n = 0, num = 0;
	unsigned int start, split, end;
	char *out, *digits = "pi1m.txt", *vcache = "vcache.dat", *v0cache =
		"v0cache.dat";
	FILE *fp;
	signed char c;
#ifndef HPAPINE
	unsigned int kk = 0, mem;
#endif

	init_k = k = sat_pop_real();
	init_n = n = sat_pop_real();

#ifndef HPAPINE
	mem = freemem();
	while (mem > BASE_OVERHEAD + (kk + 1) * RECURSE_OVERHEAD)
		kk++;
	kk--;

	if (k == 0 && n == 0)
		init_k = k = kk;

	if (BASE_OVERHEAD + (k + 1) * RECURSE_OVERHEAD > mem) {
		char errormsg[50];
		sprintf(errormsg, "k=%d too large, try=%d", k, kk);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}
#endif

	if ((fp = fopen(digits, "r")) == NULL) {
		char errormsg[50];
		sprintf(errormsg, "Cannot read: %s", digits);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}

	sys_slowOff();

	decContextDefault(&set, DEC_INIT_BASE);
	set.traps = 0;
	set.digits = DECNUMDIGITS;

	decNumberFromString(&one, "1", &set);
	decNumberFromString(&two, "2", &set);
	decNumberFromString(&four, "4", &set);
	recordsize = sizeof(decNumber);

	clear_screen();
	printf("Vieta Accelerated 3\n");
	printf("-------------------\n");

	if (n == 0) {
		decNumber fours, Ck, temp, three, dk, pi, ten;
		char out[DECNUMDIGITS + 20];

		printf("Computing C(%d) ~ ", k);
		decNumberFromString(&pi, "3.14159265358979", &set);
		decNumberFromString(&ten, "10", &set);

		if (k > 0) {
			decNumberFromString(&fours, "1", &set);
			decNumberFromString(&Ck, "1", &set);
			decNumberFromString(&three, "3", &set);
			sprintf(buf, "%d", k);
			decNumberFromString(&dk, buf, &set);

			for (i = 0; i < k; i++) {
				decNumberMultiply(&fours, &fours, &four, &set);
				decNumberSubtract(&temp, &fours, &one, &set);
				decNumberMultiply(&Ck, &Ck, &temp, &set);
			}

			decNumberMultiply(&temp, &dk, &two, &set);
			decNumberAdd(&temp, &temp, &three, &set);
			decNumberPower(&temp, &two, &temp, &set);
			decNumberMultiply(&Ck, &Ck, &temp, &set);

			for (i = 2; i <= (2 * k + 3); i++) {
				sprintf(buf, "%d", i);
				decNumberFromString(&temp, buf, &set);
				decNumberMultiply(&Ck, &Ck, &temp, &set);
			}

			decNumberDivide(&Ck, &one, &Ck, &set);
			decNumberMultiply(&temp, &dk, &two, &set);
			decNumberAdd(&temp, &temp, &three, &set);
			decNumberPower(&temp, &pi, &temp, &set);
			decNumberMultiply(&Ck, &Ck, &temp, &set);

			decNumberToString(&Ck, out);
			for (i = 0; i < 3; i++) {
				printf("%c", out[i]);
			}

			i = 0;
			while (decNumberIsLess(Ck, one, set)) {
				decNumberMultiply(&Ck, &Ck, &ten, &set);
				i++;
			}
		} else {
			i = 0;
		}
		printf("E-%d\n", i);

		init_n = n = ((MAXDIGITS) - i) / (((double) k + 1) * .6) + 1;
	} else {
		printf("\n");
	}

	thits = k * (k + 1) - 2 * k + 1;
	vhits = 0;

	printf("Computing 2*V(%d,%d)\n", k, n);
	printf("Computing V(0,n): ");

	start = sys_RTC_seconds();

#ifndef HPAPINE
	FSOpen(v0cache, FSMODE_WRITE | FSMODE_READ | FSMODE_MODIFY, &v0fp);
	if (v0fp == NULL) {
#else
	if ((v0fp = fopen(v0cache, "wb+")) == NULL) {
#endif
		char errormsg[50];
		sprintf(errormsg, "Cannot open: %s", v0cache);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}

	init_V0(k, n, set);

	if (optout) {
		sat_stack_push_string("Optout detected!");
		sat_push_real(1);
		return (0);
	}

	gotoxy(18, 4);
	printf("100%%");
	split = end = sys_RTC_seconds();
	gotoxy(23, 4);
	printf("%7d s", end - start);
	gotoxy(0, 5);
	printf("Computing V(k,n): ");

#ifndef HPAPINE
	FSOpen(vcache, FSMODE_WRITE | FSMODE_READ | FSMODE_MODIFY, &vfp);
	if (vfp == NULL) {
#else
	if ((vfp = fopen(vcache, "wb+")) == NULL) {
#endif
		char errormsg[50];
		sprintf(errormsg, "Cannot open: %s", vcache);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	} else {
		decNumber zero;

		decNumberZero(&zero);

		for (i = 0; i < k * (k + 1) / 2; i++) {
#ifndef HPAPINE
			FSWrite((char *) &zero, recordsize, vfp);
#else
			fwrite(&zero, recordsize, 1, vfp);
#endif
		}
	}

	Vieta(k, n, &p, set);
	end = sys_RTC_seconds();

#ifndef HPAPINE
	FSCloseAndDelete(vfp);
	FSCloseAndDelete(v0fp);
	syscallArg0(19);
#else
	fclose(vfp);
	fclose(v0fp);
#endif

	gotoxy(18, 5);
	printf("100%%");
	gotoxy(23, 5);
	printf("%7d s", end - split);

	decNumberMultiply(&p, &p, &two, &set);
	out = malloc((DECNUMDIGITS + 14) * sizeof(char));
	decNumberToString(&p, out);

	i = 0;
	while ((c = fgetc(fp)) != EOF) {
		if (isdigit(c)) {
			if (out[i] == '.')
				i++;
			if (c == out[i++])
				num++;
			else
				break;
		}
	}
	fclose(fp);

	gotoxy(0, 7);
	printf("digits          = %d\n", num);
	printf("time(s)         = ");
	if (end - start >= 0)
		printf("%d\n", end - start);
	else
		printf("%d\n", end - start + 86400);
#ifndef HPAPINE
	printf("free memory     = %d bytes\n", mem);
#endif
	printf("decNumber bytes = %d\n", (int) (sizeof(decNumber) * (k + 1)));
	printf("decNum SD bytes = %d\n",
		   (int) (sizeof(decNumber) * ((k + 1) + k * (k + 1) / 2)));
	printf("decNumber size  = %d bytes", (int) (sizeof(decNumber)));

	beep();
	sys_slowOn();
	WAIT_CANCEL;
	sat_push_zint_llong(k);
	sat_stack_push_string("k");
	sat_push_zint_llong(n);
	sat_stack_push_string("n");
	sat_push_zint_llong(num);
	sat_stack_push_string("digits");
	sat_push_zint_llong(end - start);
	sat_stack_push_string("time");
#define PROG_LEFT   171
#define PROG_RIGHT  187
#define ARROW_RIGHT 141
#ifndef HPAPINE
	sprintf(rpl, "%c 7 4 FOR i %cTAG i ROLLD -1 STEP %c", PROG_LEFT,
			ARROW_RIGHT, PROG_RIGHT);
	sat_stack_push_string(rpl);
#endif
	sat_push_real(0);
	return (0);
}

void init_V0(int k, int n, decContext set)
{
	decNumber s, u, t;
	int i;

	decNumberFromString(&s, "0", &set);
	decNumberFromString(&t, "1", &set);

	for (i = 0; i < k + n; i++) {
		// s = s + 2
		decNumberAdd(&s, &s, &two, &set);
		// s = sqrt(s)
		decNumberSquareRoot(&s, &s, &set);
		// u = s / 2
		decNumberDivide(&u, &s, &two, &set);
		// t = t * u
		decNumberMultiply(&t, &t, &u, &set);

		if (i >= (n - 1)) {
			decNumberDivide(&V0, &one, &t, &set);
#ifndef HPAPINE
			FSWrite((char *) &V0, recordsize, v0fp);
#else
			fwrite(&V0, recordsize, 1, v0fp);
#endif
		}

		gotoxy(18, 4);
		printf("%3d%%", (int) ((i * 100.0) / (float) (k + n - 1) + .5));

		if (keyb_isAnyKeyPressed()) {
			beep();
			optout = 1;
			return;
		}
	}
}

void Vieta(int k, int n, decNumber * p, decContext set)
{
#define DIFFK (init_k - k)
	int addr;

	if (k == 0) {
#ifndef HPAPINE
		FSSeek(v0fp, ((n - init_n) * recordsize), 0);
		FSRead((char *) &V0, recordsize, v0fp);
#else
		fseek(v0fp, ((n - init_n) * recordsize), 0);
		fread(&V0, recordsize, 1, v0fp);
#endif
		decNumberCopy(p, &V0);
		return;
	}

	vhits++;
	gotoxy(18, 5);
	printf("%3d%%", (int) ((vhits * 100.0) / (float) (thits) + .5));
	addr = DIFFK * (DIFFK + 1) / 2 + DIFFK + (init_n - n);
#ifndef HPAPINE
	FSSeek(vfp, (addr * recordsize), 0);
	FSRead((char *) &V, recordsize, vfp);
#else
	fseek(vfp, (recordsize * addr), 0);
	fread(&V, recordsize, 1, vfp);
#endif
	if (!decNumberIsZero(&V)) {
		decNumberCopy(p, &V);
		return;
	} else {
		decNumber res;

		sprintf(buf, "%d", k);
		decNumberFromString(&V, buf, &set);
		// p = 4^k
		decNumberPower(p, &four, &V, &set);
		// res = Vieta(k-1,n+1)
		Vieta(k - 1, n + 1, &res, set);
		// p = p * res
		decNumberMultiply(p, p, &res, &set);
		// res = Vieta(k-1,n)
		Vieta(k - 1, n, &res, set);
		// p = p - res
		decNumberSubtract(p, p, &res, &set);
		// res = 4^k
		sprintf(buf, "%d", k);
		decNumberFromString(&V, buf, &set);
		decNumberPower(&res, &four, &V, &set);
		// res = res - 1
		decNumberSubtract(&res, &res, &one, &set);
		// p = p / res
		decNumberDivide(p, p, &res, &set);
#ifndef HPAPINE
		FSSeek(vfp, (addr * recordsize), 0);
		FSWrite((char *) p, recordsize, vfp);
		//decNumberCopy(&V,p);
		//FSWrite((char*)&V,recordsize,vfp);
#else
		fseek(vfp, (recordsize * addr), 0);
		fwrite(p, recordsize, 1, vfp);
#endif
	}
}

int decNumberIsLess(decNumber a, decNumber b, decContext set)
{
	decNumber cmp;

	decNumberCompare(&cmp, &a, &b, &set);
	return (decNumberIsNegative(&cmp));
}

#ifndef HPAPINE
int freemem()
{
	register unsigned int stack_ptr asm("sp");
	unsigned int base;

	base = (__heap_ptr == 0) ? _heap_base_addr : __heap_ptr;

	return stack_ptr - base;
}
#endif
