#define  MAXDIGITS 5000
#define  DECNUMDIGITS (MAXDIGITS + (MAXDIGITS/1000))
#define  BASE_OVERHEAD 20000
#define  BUFSIZE 10
#include <decNumber.h>
#include <hpgcc49.h>

#ifndef HPAPINE
extern unsigned int __heap_ptr, _heap_base_addr;
int freemem();
#endif

int decNumberIsLess(decNumber, decNumber, decContext);
void Vieta(int k, decContext set);
void init_V(int k, int n, decContext set);

decNumber one, two, four;
decNumber *V;
int init_k, init_n, optout = 0;
char rpl[100], buf[BUFSIZE];

int main(int argc, char **argv)
{
	decContext set;
	int i, k = 0, n = 0, num = 0;
	unsigned int start, split, end;
	char *out, *digits = "pi1m.txt";
	FILE *fp;
	signed char c;
#ifndef HPAPINE
	unsigned int kk = 0, mem;
#endif

	init_k = k = sat_pop_real();
	init_n = n = sat_pop_real();

#ifndef HPAPINE
	mem = freemem();
	while (mem > sizeof(decNumber) * (kk + 1) + BASE_OVERHEAD)
		kk++;
	kk--;

	if (k == 0 && n == 0)
		init_k = k = kk;

	if (sizeof(decNumber) * (k + 1) + BASE_OVERHEAD > mem) {
		char errormsg[50];
		sprintf(errormsg, "k=%d too large, try=%d", k, kk);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}
#endif

	if ((fp = fopen(digits, "r")) == NULL) {
		char errormsg[50];
		sprintf(errormsg, "Cannot read: %s", digits);
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}

	sys_slowOff();

	decContextDefault(&set, DEC_INIT_BASE);
	set.traps = 0;
	set.digits = DECNUMDIGITS;

	decNumberFromString(&one, "1", &set);
	decNumberFromString(&two, "2", &set);
	decNumberFromString(&four, "4", &set);

	clear_screen();
	printf("Vieta Accelerated 4\n");
	printf("-------------------\n");

	if (n == 0) {
		decNumber fours, Ck, temp, three, dk, pi, ten;
		char out[DECNUMDIGITS + 20];

		printf("Computing C(%d) ~ ", k);
		decNumberFromString(&pi, "3.14159265358979", &set);
		decNumberFromString(&ten, "10", &set);

		if (k > 0) {
			decNumberFromString(&fours, "1", &set);
			decNumberFromString(&Ck, "1", &set);
			decNumberFromString(&three, "3", &set);
			sprintf(buf, "%d", k);
			decNumberFromString(&dk, buf, &set);

			for (i = 0; i < k; i++) {
				decNumberMultiply(&fours, &fours, &four, &set);
				decNumberSubtract(&temp, &fours, &one, &set);
				decNumberMultiply(&Ck, &Ck, &temp, &set);
			}

			decNumberMultiply(&temp, &dk, &two, &set);
			decNumberAdd(&temp, &temp, &three, &set);
			decNumberPower(&temp, &two, &temp, &set);
			decNumberMultiply(&Ck, &Ck, &temp, &set);

			for (i = 2; i <= (2 * k + 3); i++) {
				sprintf(buf, "%d", i);
				decNumberFromString(&temp, buf, &set);
				decNumberMultiply(&Ck, &Ck, &temp, &set);
			}

			decNumberDivide(&Ck, &one, &Ck, &set);
			decNumberMultiply(&temp, &dk, &two, &set);
			decNumberAdd(&temp, &temp, &three, &set);
			decNumberPower(&temp, &pi, &temp, &set);
			decNumberMultiply(&Ck, &Ck, &temp, &set);

			decNumberToString(&Ck, out);
			for (i = 0; i < 3; i++) {
				printf("%c", out[i]);
			}

			i = 0;
			while (decNumberIsLess(Ck, one, set)) {
				decNumberMultiply(&Ck, &Ck, &ten, &set);
				i++;
			}
		} else {
			i = 0;
		}
		printf("E-%d\n", i);

		init_n = n = ((MAXDIGITS) - i) / (((double) k + 1) * .6) + 1;
	} else {
		printf("\n");
	}

	printf("Computing 2*V(%d,%d)\n", k, n);
	printf("Computing V(0,n): ");

	start = sys_RTC_seconds();

	if ((V = malloc((k + 1) * sizeof(decNumber))) == NULL) {
		char errormsg[50];
		sprintf(errormsg, "Failed to allocate %d bytes of memory for V",
				(int) ((k + 1) * sizeof(decNumber)));
		sat_stack_push_string(errormsg);
		sat_push_real(1);
		return (0);
	}

	init_V(k, n, set);

	if (optout) {
		sat_stack_push_string("Optout detected!");
		sat_push_real(1);
		return (0);
	}

	gotoxy(18, 4);
	printf("100%%");
	split = end = sys_RTC_seconds();
	gotoxy(23, 4);
	printf("%7d s", end - start);
	gotoxy(0, 5);
	printf("Computing V(k,n): ");

	Vieta(k, set);

	end = sys_RTC_seconds();
	gotoxy(23, 5);
	printf("%7d s", end - split);

	decNumberMultiply(&V[0], &V[0], &two, &set);
	out = malloc((DECNUMDIGITS + 14) * sizeof(char));
	decNumberToString(&V[0], out);

	i = 0;
	while ((c = fgetc(fp)) != EOF) {
		if (isdigit(c)) {
			if (out[i] == '.')
				i++;
			if (c == out[i++])
				num++;
			else
				break;
		}
	}
	fclose(fp);

	gotoxy(0, 7);
	printf("digits          = %d\n", num);
	printf("time(s)         = ");
	if (end - start >= 0)
		printf("%d\n", end - start);
	else
		printf("%d\n", end - start + 86400);
#ifndef HPAPINE
	printf("free memory     = %d bytes\n", mem);
#endif
	printf("decNumber bytes = %d\n", (int) (sizeof(decNumber) * (k + 1)));
	printf("decNumber size  = %d bytes", (int) (sizeof(decNumber)));

	beep();
	sys_slowOn();
	WAIT_CANCEL;
	sat_push_zint_llong(k);
	sat_stack_push_string("k");
	sat_push_zint_llong(n);
	sat_stack_push_string("n");
	sat_push_zint_llong(num);
	sat_stack_push_string("digits");
	sat_push_zint_llong(end - start);
	sat_stack_push_string("Tv0+v");
	sat_push_zint_llong(split - start);
	sat_stack_push_string("Tv0");
	sat_push_zint_llong(end - split);
	sat_stack_push_string("Tv");
#define PROG_LEFT   171
#define PROG_RIGHT  187
#define ARROW_RIGHT 141
#ifndef HPAPINE
	sprintf(rpl, "%c 11 6 FOR i %cTAG i ROLLD -1 STEP %c", PROG_LEFT,
			ARROW_RIGHT, PROG_RIGHT);
	sat_stack_push_string(rpl);
#endif
	sat_push_real(0);
	return (0);
}

void init_V(int k, int n, decContext set)
{
	decNumber s, u, t;
	int i;

	decNumberFromString(&s, "0", &set);
	decNumberFromString(&t, "1", &set);

	for (i = 0; i < k + n; i++) {
		// s = s + 2
		decNumberAdd(&s, &s, &two, &set);
		// s = sqrt(s)
		decNumberSquareRoot(&s, &s, &set);
		// u = s / 2
		decNumberDivide(&u, &s, &two, &set);
		// t = t * u
		decNumberMultiply(&t, &t, &u, &set);

		if (i >= (n - 1))
			decNumberDivide(&V[i - (n - 1)], &one, &t, &set);

		gotoxy(18, 4);
		printf("%3d%%", (int) ((i * 100.0) / (float) (k + n - 1) + .5));

		if (keyb_isAnyKeyPressed()) {
			beep();
			optout = 1;
			return;
		}
	}
}

void Vieta(int k, decContext set)
{
	decNumber k4, t1, t2;
	int i, j, m = k;
	int thits = k * (k + 1) / 2;
	int vhits = 0;

	decNumberFromString(&k4, "1", &set);

	for (j = 0; j < k; j++) {
		decNumberMultiply(&k4, &k4, &four, &set);
		for (i = 0; i < m; i++) {
			vhits++;
			gotoxy(18, 5);
			printf("%3d%%",
				   (int) ((vhits * 100.0) / (float) (thits) + .5));

			decNumberMultiply(&t1, &k4, &V[i + 1], &set);
			decNumberSubtract(&t1, &t1, &V[i], &set);
			decNumberSubtract(&t2, &k4, &one, &set);
			decNumberDivide(&V[i], &t1, &t2, &set);
		}

		m--;
	}
}

int decNumberIsLess(decNumber a, decNumber b, decContext set)
{
	decNumber cmp;

	decNumberCompare(&cmp, &a, &b, &set);
	return (decNumberIsNegative(&cmp));
}

#ifndef HPAPINE
int freemem()
{
	register unsigned int stack_ptr asm("sp");
	unsigned int base;

	base = (__heap_ptr == 0) ? _heap_base_addr : __heap_ptr;

	return stack_ptr - base;
}
#endif
